﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;

namespace 言語バー空気嫁 {
    static class Win32 {
        [DllImport("user32.dll")]
        public static extern IntPtr FindWindow(
            string lpClassName,  // クラス名
            string lpWindowName  // ウィンドウ名
        );

        [DllImport("user32.dll")]
        public static extern int GetWindowRect(
            IntPtr hWnd,      // ウィンドウのハンドル
            out RECT lpRect   // ウィンドウの座標値
        );

        [DllImport("user32.dll")]
        public static extern int SetWindowPos(
            IntPtr hWnd,             // ウィンドウのハンドル
            IntPtr hWndInsertAfter,  // 配置順序のハンドル
            int X,                 // 横方向の位置
            int Y,                 // 縦方向の位置
            int cx,                // 幅
            int cy,                // 高さ
            uint uFlags            // ウィンドウ位置のオプション
        );

        [DllImport("user32.dll")]
        public static extern IntPtr GetForegroundWindow();

        [StructLayout(LayoutKind.Sequential)]
        public struct RECT {
            public int left;
            public int top;
            public int right;
            public int bottom;

            public static bool operator==(RECT a ,RECT b){
                return a.bottom == b.bottom && 
                    a.left == b.left &&
                    a.right == b.right &&
                    a.top == b.top;
            }

            public static bool operator !=(RECT a, RECT b) {
                return !(a == b);
            }

            public override bool Equals(object obj) {
                return base.Equals(obj);
            }

            public override int GetHashCode() {
                return base.GetHashCode();
            }
        }

        [StructLayout(LayoutKind.Sequential)]
        public struct POINT {
            public int x;
            public int y;
        }

        [StructLayout(LayoutKind.Sequential)]
        public struct GUITHREADINFO {
            public uint cbSize;
            public uint flags;
            public IntPtr hwndActive;
            public IntPtr hwndFocus;
            public IntPtr hwndCapture;
            public IntPtr hwndMenuOwner;
            public IntPtr hwndMoveSize;
            public IntPtr hwndCaret;
            public RECT rcCaret;
        }

        [DllImport("user32.dll")]
        public static extern int GetGUIThreadInfo(uint dwthreadid, ref GUITHREADINFO lpguithreadinfo);

        [DllImport("user32.dll")]
        public static extern uint GetWindowThreadProcessId(
            IntPtr hWnd,             // ウィンドウのハンドル
            ref uint lpdwProcessId  // プロセス ID
        );

        [DllImport("user32.dll")]
        public static extern int ClientToScreen(
            IntPtr hWnd,       // ウィンドウのハンドル
            ref POINT lpPoint  // クライアント座標
        );

        [DllImport("user32.dll")]
        public static extern int GetClassName(
            IntPtr hWnd,           // ウィンドウのハンドル
            StringBuilder lpClassName,  // クラス名
            int nMaxCount        // クラス名バッファのサイズ
        );

        public const int SWP_NOSIZE = 0x0001;
        public const int SWP_NOZORDER = 0x0004;
        public const int SWP_NOACTIVATE = 0x0010;
    }
}
